<?php
/***********************************************************************************/
/*                                                                                 */
/* This file is part of POPMail (config-mail.php).                                 */
/*                                                                                 */
/* POPMail is free software; you can redistribute it and/or modify                 */
/* it under the terms of the GNU General Public License as published by            */
/* the Free Software Foundation; either version 2 of the License, or               */
/* (at your option) any later version.                                             */
/*                                                                                 */
/* POPMail is distributed in the hope that it will be useful,                      */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of                  */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the                   */
/* GNU General Public License for more details.                                    */
/*                                                                                 */
/* You should have received a copy of the GNU General Public License               */
/* along with POPMail; if not, write to the Free Software                          */
/* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA       */
/*                                                                                 */
/***********************************************************************************/

                           #################################
                           # Variables that you may modify #
                           #################################

################################
# LANGUAGE for system displays ######################################################
################################
# english & german language files come with program.
# Download additional languages files from website at:
# http://www.tinned-software.net/tinned-mail/index.php?ps=download&l=en
# Place file into the language directory for popmail such as dutch.php
# e.g. http://your.domain.com/popmail/language/dutch.php
# Replace default file name below with desired language file name without extension
# (e.g. $languageFile = "dutch";) - use lowercase for the name - "english" = default
# Setting is also changeable in Preferences (Pref) menu.
$languageFile = "english";

##################################
# STYLESHEET for system displays ####################################################
##################################
# Enter desired display: "standard","lightblue","lightgreen","yellow".
# "lightblue" = default
# Setting is also changeable in Preferences (Pref) menu.
$stylesheet = "lightblue";

################
# LOGOUT timer ######################################################################
################
# Timer in seconds to automatically log you out, counting down since logon.
# To determine seconds: 60 seconds in a minute X # of minutes to stay logged on.
# "2000" = default, "" value prevents logging out of program.
# Setting is also changeable in Preferences (Pref) menu.
$logout = "2000";

######################################################
# Messagelist delay before list is ready for display ################################
######################################################
# Allows messagelist to be fully created before displaying that list.
# "0" = disabled, "1" = enabled and default
$MsglistDelay = "1";

#############################################################
# Number of messages to be displayed at once in Messagelist #########################
#############################################################
# Allows long or short display of messagelist.
# 0 = show all messages, 1 or higher limits the display to that count.
# Setting is also changeable in Preferences (Pref) menu.
$ListMessages = "0";

#####################################
# Name of incoming POP3 mail server #################################################
#####################################
# Enter name or IP of your single, fixed POP3 mail server (e.g. mail.yourdomain.com).
# $fixedServer = "" forces manual name entry of mail server at logon.
# $changeableServer = "yes" below may used at the same time with this entry.
# Change name to your mail server
$fixedServer = ""; 

########################################
# Multiple incoming mail servers usage ##############################################
########################################
# Allows more than one POP3 mail server to be used.
# $fixedServer name entry above may be used at the same time with this entry.
# "yes" = enable and default, "no" = disable
$changeableServer = "yes";

###############################################################
# POP3 SERVER NAME & SERVER PORT info displayed on login page #######################
###############################################################
# Hides POP3 server name & server port on login page.
# For security, you should hide settings after testing has been completed.
# "0" = show info and default, "1" = hide info
$hideServer = 0;

#####################################
# POP3 PORT on incoming mail server #################################################
#####################################
# Enter POP3 Port for incoming mail server.
# Do not change unless you know for sure a different port is required.
# $fixedServerPort = "" forces POPMail to use port 110 - "110" = default
$fixedServerPort = "110";

###########################
# Message text field size ###########################################################
###########################
# Enter different values to change display form size.
# This is the email typing form used when composing the message body.
# Default values: $msg_rows = 20 & $msg_cols = 80
$msg_rows = 20;
$msg_cols = 80;

##################################
# Your full name & email address ####################################################
##################################
# For single POP3 user account for incoming mail server.
# Enter your full name & email address, e.g. "Your Name <user@mydomain.com>"
# Forces auto-fill of form with this info when composing a message - "" = default
$fixedSender = "";

##################
# Your full name ####################################################################
##################
# For single POP3 user account for incoming mail server.
# Enter your full name, e.g. "Your Name"
# Forces auto-fill of form with this info when composing a message - "" = default
$fixedUser = "";

############################################
# FROM field editing when writing an email ##########################################
############################################
# User may enter any email address into the FROM-field when composing a message.
# "no" = disable and default, "yes" = enable
$changeableSender = "no";

##########################################
# AUTHENTICATION required by SMTP server ############################################
##########################################
# This is used when your SMTP server requires an authenticated username & password.
# Authentication works if POP3 & SMTP servers end in same host name,
# e.g. pop3.samedomain.com and smtp.samedomain.com 
# Using a SMTP server not ending with same POP3 server host name will not work,
# e.g. pop3.mydomain.com and smtp.otherdomain.com
# "0" = disable and default, "1" = enable
$useSMTPauth = 0;

#####################################
# SIGNATURE block at end of message #################################################
#####################################
# TEXT signature only, no graphics or HTML - default = ""
# To made a clickable URL link, use text and most mail clients will display the link,
# e.g. http://www.tinned-software.net
# Automatically adds a personalized signature line to end of all the outgoing messages
# if no user specific signature is set through the Preferences (Pref) menu.
$signature = "";

######################################
# FOOTER line at end of each message ################################################
######################################
# Most mail clients will recognize and display URL as a clickable link.
# The footer is automatically added to each outgoing message, it is not visible 
# while composing the message and thus cannot be changed by the user. 
# The \n designation forces a new line went invoked.
# "\n--------------------\nViit us at http://www.tinned-software.net" = default
$footer = "\n--------------------\nVisit us at http://www.tinned-software.net";

#########################
# ADDRESSBOOK file name #############################################################
#########################
# You may use any text file to store your encrypted email addresses.
# Replace address.txt by uploading new text file into the popmail directory or
# rename this file on your server in the popmail directory.
# "address.txt" = default
$addressbook = "address.txt";

#####################################################
# Encryption string for addressbook email addresses #################################
#####################################################
# This string encrypts all email addresses in the addressbook to make them secure.
# If you change this when there are already entries in the addressbook, you will
# not be able to view those entries properly. You will need to delete all entries
# in the addressbook file and re-enter them as new. String may be any length.
# "whateveryouwant" = default
$encrypter = "whateveryouwant";

#############################                           #############################
# !!! DO NOT EDIT BELOW !!! ############################# !!! DO NOT EDIT BELOW !!! #
#############################                           #############################
$ralphabet = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz1234567890 \\!.:?~@#\$%^&*()_+-=][}{/><\"'`|";
$alphabet = $ralphabet . $ralphabet;
?>
