<?php
/***********************************************************************************/
/*                                                                                 */
/* This file is part of POPMail.                                                   */
/*                                                                                 */
/* POPMail is free software; you can redistribute it and/or modify                 */
/* it under the terms of the GNU General Public License as published by            */
/* the Free Software Foundation; either version 2 of the License, or               */
/* (at your option) any later version.                                             */
/*                                                                                 */
/* POPMail is distributed in the hope that it will be useful,                      */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of                  */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the                   */
/* GNU General Public License for more details.                                    */
/*                                                                                 */
/* You should have received a copy of the GNU General Public License               */
/* along with POPMail; if not, write to the Free Software                          */
/* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA       */
/*                                                                                 */
/***********************************************************************************/

# PLEASE DO NOT EDIT THIS FILE. NO SUPPORT IS
# GIVEN WHEN YOU CHANGE SOMETHING IN THIS FILE!!!
$version_internal = "0.24";
$smtp_port=25;
$debug=0; 			// for viewing smtp communication WARNING: complete mail is displayed (with attachements)!

function setPriority($priority){
    $priorities = array('1 (Highest)', '2 (High)', '3 (Normal)', '4 (Low)', '5 (Lowest)');
    if(!intval($priority)){
        error($GLOBALS["s_sentNoPriority"],1,1,$GLOBALS["stylesheet"]);
    }
    if(!isset( $priorities[$priority-1])){
        error($GLOBALS["s_sentNoPriority"],1,1,$GLOBALS["stylesheet"]);
    }
    return "X-Priority: ".$priorities[$priority-1]."\n";
}

function setFrom($from){
    if (!$from){
        error($GLOBALS["s_sentNoFrom"],1,1,$GLOBALS["stylesheet"]);
    }
    else {
        $fromText = stripslashes($from);
        if(!is_string($fromText)){
            error($GLOBALS["s_sentWrongFrom"],1,1,$GLOBALS["stylesheet"]);
        }
    }
    return "From: $fromText\n";
}

function checkSMTPAnswer($answer, $socket){
    if(substr($answer,0,3) >= 500){
        fputs ($socket, "QUIT\r\n");
        $smtp_answer = fgets ($socket, 1024);
        fclose($socket);
        error($GLOBALS["s_emailNotSent"] . " " . $answer,1,1,$GLOBALS["stylesheet"]);
    }
}

if (!$toText) {
    error($s_noRecipient,1,1,$GLOBALS["stylesheet"]);
}

if (!eregi("[_.a-z0-9]+@[a-z0-9]+", $toText)) {
    error($s_invalidRecipient,1,1,$GLOBALS["stylesheet"]);
}

if (!$smtp_server) {
    error($GLOBALS["s_noSMTP"],1,1,$GLOBALS["stylesheet"]);
}

$toText = stripslashes($toText);
$subjectText = stripslashes($subjectText);
$msgText = stripslashes($msgText);

$positie = strpos($msgText,$message);
$part1 = substr($msgText,0,$positie);
$part2 = substr($msgText,$positie);

$msgText = $part1;
$msgText .= $part2;
//$msgText .= "\n\n".$signature."\n\n";
$msgText .= "\n\n".$footer."";

$headers  = setFrom($fromText);

$headers .= "To: $toText\n";
if ($ccText) {
    $headers .= "CC: $ccText\n";
}

$headers .= "Subject: $subjectText\n";
$headers .= "MIME-Version: 1.0\n";
$headers .= setPriority($priority);
if($read_notification) {
    $headers .= "Disposition-Notification-To: $fromText\n";
}
$headers .= "X-Mailer: PHP/POPMail $version\n";
$headers .= "Date: " . date('r') . "\n";

if ($File_att) {
    $fil_type = "application/unknown";
    $boundary = uniqid("POPMail");
    $headers .= "Content-Type: multipart/mixed; boundary=\"$boundary\"\n";
    $msgText = "--$boundary\nContent-Type: text/plain; charset=\"UTF-8\"\nContent-Transfer-Encoding: 8bit\n\n" . utf8_encode($msgText) . "\n\n";
    foreach($File_name as $key => $value){
        $filindhold = chunk_split(base64_encode($Files_attached[$File_name[$key]]));
        $disposition = "attachment";
        $encoding = "base64";
        $fil_name = $File_name[$key];
        $msgText .= "--$boundary\nContent-Type: $fil_type; name=\"$fil_name\"\nContent-Transfer-Encoding: $encoding\nContent-Disposition: $disposition; filename=\"$fil_name\"\n\n$filindhold\n";
    }
    $msgText .= "\n--$boundary--";
    $files_temp = "";
    $_SESSION["Files_attached"] = $files_temp;
}
else {
    $headers .= "Content-Type: text/plain; charset=\"UTF-8\"\r\n";
    $msgText = utf8_encode($msgText);
}

if ($save_message){
    $mail_copy[0]  = "Return-Path: <$fromText>\n";
    $mail_copy[0] .= "Date: ".date("r",time())."\n";
    $mail_copy[0] .= $headers;
    $mail_copy[0] .= "Status: RO\n";
    $msgText_save = preg_replace("/\nFrom /", "\n>From ", $msgText);
    $mail_copy[0] .= "\n$msgText_save\n";
    $type = "add";
    $deleteMessage = "1";
//    $tofolder = $tofolder;
    include("prog_mail_file.php");
}

// prepare envelop senders
if (strstr($fromText, "<") && strstr($fromText, ">")){
    list($name, $email) = split("<", $fromText);
    $smtpFrom = substr($email, 0, -1);
}
else $smtpFrom = $fromText;

// preparing Message text for sending
$MessageText  = "$headers\r\n";
$msgLines = preg_split("/[\r]\n/",$msgText);
$a=0;
while($msgLines[$a]){
    $msgLines[$a] = chop($msgLines[$a]);
    // when only "." is in a line the "." should be doubled ("..")
    if($msgLines[$a] == "."){
        $msgLines[$a] = "..";
    }
    $a++;
}
$msgText = join("\r\n",$msgLines);
$MessageText .= "$msgText\r\n";

// check if all newline consists of "CR LF"
$MessageText = preg_replace("/\r/", "", $MessageText);
$MessageText = preg_replace("/\n\.\n/", "\n..\n", $MessageText);
$MessageText = preg_replace("/\n/", "\r\n", $MessageText);
// $debug_filename = $GLOBALS["PHPSESSID"]."dbg";
// $fpdbg = fopen($debug_filename, "w");
// fwrite($fpdbg, $MessageText);
// fclose($fpdbg);

// connect to smtp server
if($debug > 0){echo "<b>Debug Results:</b><br>"; echo "Connecting to SMTP mail server " . $smtp_server . ":" . $smtp_port . ".<br>";}
$fp = fsockopen($smtp_server,$smtp_port) or error($GLOBALS["s_emailNotSent"] . "<br>" . $GLOBALS["s_smtpNoConnection"],1,1,$GLOBALS["stylesheet"]);
$smtp_answer=fgets($fp, 1024);
if (!$fp) return false;

if ($fp && $debug > 0) {echo "Connected.<br>"; echo "$smtp_answer<br>";}

// say hello to the server.
fputs($fp, "HELO {$_SERVER['SERVER_NAME']}\r\n");
$smtp_answer = fgets($fp, 1024); 
if($debug > 0){echo "HELO {$_SERVER['SERVER_NAME']}<br>"; echo "$smtp_answer<br>";}
checkSMTPAnswer($smtp_answer, $fp);

// reset communication
fputs($fp, "RSET\r\n");
$smtp_answer = fgets($fp, 1024);
if($debug > 0){echo "RSET<br>"; echo "$smtp_answer<br>";}
checkSMTPAnswer($smtp_answer, $fp);

// set sender address
$smtpFrom = preg_replace("/.*[ ^\<\"]([a-zA-Z0-9._-]+@[a-zA-Z0-9-]+\.[a-zA-Z.]{2,6}).*/", "\$1", $smtpFrom);
fputs($fp, "MAIL FROM: $smtpFrom\r\n");
$smtp_answer = fgets($fp, 1024);

// authentication required error (Authentication is required to send mail as) if server error code = 553
// system closes as a result of code = 553 to end debug session
if(substr($smtp_answer,0,3) == 553){
    if($debug > 0){echo "$smtp_answer<br>"; echo "&lt;" . $smtpFrom . "&gt;<br>";}
    if($debug > 0){echo "QUIT<br>"; echo "Disconnected.<br>";}
    if($debug > 0){echo "<b>End of DEBUG!</b><br><br>";}
}else{
    if($debug > 0){echo "MAIL FROM: &lt;" . $smtpFrom . "&gt;<br>"; echo "$smtp_answer<br>";}
}

checkSMTPAnswer($smtp_answer, $fp);

// set recipent address
$rcpts = $toText.",".$ccText.",".$bccText;
// $rcpts = preg_replace("/ /", "", $rcpts);
$rcpts_temp = split(",",$rcpts);
$add = "";
foreach($rcpts_temp as $rcpt){
    $rcptEnvelop = preg_replace("/.*[ ^\<\"]([a-zA-Z0-9._-]+@[a-zA-Z0-9-]+\.[a-zA-Z.]{2,6}).*/", "\$1", $rcpt);

    if($deliver_notification) {
        $add = "  NOTIFY=SUCCESS";
    }

    if($rcptEnvelop){ 
        fputs($fp, "RCPT TO: <$rcptEnvelop>$add\r\n");
//        fputs($fp, "RCPT TO: $rcptEnvelop\r\n");
        $smtp_answer = fgets($fp, 1024);
        if($debug > 0){echo "RCPT TO: &lt;" . $rcptEnvelop . "&gt;$add<br>"; echo "$smtp_answer<br>";}
        checkSMTPAnswer($smtp_answer, $fp);
    }
}
// set Message Text to the smtp server
fputs($fp, "DATA\r\n");
$smtp_answer = fgets($fp, 1024);
if($debug > 0){echo "DATA<br>"; echo "$smtp_answer<br>";}
checkSMTPAnswer($smtp_answer, $fp);

fputs($fp, "$MessageText\r\n.\r\n");
$smtp_answer = fgets($fp, 1024);
if($debug > 0){echo preg_replace("/[\r]*\n/", "<br>\n", $MessageText) . "<br>$smtp_answer<br>";}
checkSMTPAnswer($smtp_answer, $fp);

//evaluate the latest answer before closing the connection
//to see if the mail was send or not
if (!strcasecmp(substr($smtp_answer, 0, 3), "250")) {
    echo $GLOBALS["s_emailSent"] . "<br>\n";
    echo "$toText";
    if ($ccText)
        echo ", $ccText";
    if ($bccText)
        echo ", $bccText";
}
else error($GLOBALS["s_emailNotSent"], 1, 1, $GLOBALS["stylesheet"]);

// disconnect command
fputs ($fp, "QUIT\r\n");
$smtp_answer = fgets ($fp, 1024);
fclose($fp);
if($debug > 0){echo "<br>QUIT<br>"; echo "$smtp_answer<br>"; echo "Disconnected.<br>";}
if($debug > 0){echo "<b>End of DEBUG!</b><br><br>";}

?>