<?php
/*****************************************************************************/
/*                                                                           */
/* This file is part of POPMail.                                             */
/* Copyright (C) 2005                                                        */
/*                                                                           */
/* This program is free software; you can redistribute it and/or modify      */
/* it under the terms of the GNU General Public License as published by      */
/* the Free Software Foundation; either version 2 of the License, or         */
/* (at your option) any later version.                                       */
/*                                                                           */
/* This program is distributed in the hope that it will be useful,           */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of            */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             */
/* GNU General Public License for more details.                              */
/*                                                                           */
/* You should have received a copy of the GNU General Public License         */
/* along with this program; if not, write to the Free Software               */
/* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */
/*                                                                           */
/*****************************************************************************/

/*****************************************************************************/
/* PLEASE DO NOT EDIT THIS FILE. NO SUPPORT IS                               */
/* GIVEN WHEN YOU CHANGE SOMETHING IN THIS FILE!!!                           */
/*****************************************************************************/

### Internal information variables
$version_internal = "3.b1.16.light.2";
if(isset($GLOBALS['Version_Get'])){ return; }

/*****************************************************************************/
/*                     PROGRAMM STARTS AFTER THIS LINE                       */
/*****************************************************************************/


function myErrorHandler_std($errno, $errstr, $errfile, $errline){
    //echo "<b>$errno:</b> $errstr in <b>$errfile</b> on line <b>$errline</b><br>\n";
	//error_log("myErrorHandler_std: $errno: $errstr in $errfile on line $errline.\r\n", 3, "userdata/myErrorHandler.log");
}


//$old_error_handler = set_error_handler("myErrorHandler_std");
//error_log("\r\n--------------------Program-Start--------------------\r\n", 3, "userdata/myErrorHandler.log");
error_reporting('FATAL' | 'ERROR' | 'WARNING');


register_globals_session();


/*****************************************************************************/
/* SHORT:                                                                    */
/*   Part to solve register_globals problem                                  */
/*                                                                           */
/* DESCRIPTION:                                                              */
/*   This function solve the problem with the register_globals. when the     */
/*   register_globals in the php.ini is set to "no" the variables are set    */
/*   within this part. hen a session is available the session is started     */
/*   and also the session variables are registert in the GLOBALS.            */
/*   needed for PHP >=4.3.0                                                  */
/*                                                                           */
/* REQUIRE:                                                                  */
/*                                                                           */
/* INPUT:                                                                    */
/*   void                                                                    */
/*                                                                           */
/* OUTPUT:                                                                   */
/*   void                                                                    */
/*                                                                           */
/* ERROR:                                                                    */
/*                                                                           */
/* TESTED WITH:                                                              */
/*   Apache 2.0.50 / PHP 4.3.9    / Win32                                    */
/*   Apache 1.3.19 / PHP 4.0.4pl1 / Linux                                    */
/*   Apache 1.3.29 / PHP 4.3.2    / MacOSX (Darwin)                          */
/*                                                                           */
/*****************************************************************************/
function register_globals_session(){
    //$reg_glob_dbg = 1;
    $reg_global_steps = "";
    if(!ini_get('register_globals')){
        // register server variables to global
        if(isset($GLOBALS["HTTP_SERVER_VARS"])){
            if(isset($reg_glob_dbg)){ $reg_global_steps .= "Register: HTTP_SERVER_VARS (".count($GLOBALS["HTTP_SERVER_VARS"])."<br>\n"; }
            foreach($GLOBALS["HTTP_SERVER_VARS"] as $key => $value){
                $GLOBALS[$key] = $GLOBALS["HTTP_SERVER_VARS"][$key];
            }
        }
        else{
            if(isset($reg_glob_dbg)){ $reg_global_steps .= "Register: _SERVER (".count($GLOBALS["_SERVER"]).")<br>\n"; }
            foreach($GLOBALS["_SERVER"] as $key => $value){
                $GLOBALS[$key] = $GLOBALS["_SERVER"][$key];
            }
        }
        
        // register cookie variables to global
        if(isset($GLOBALS["HTTP_COOKIE_VARS"])){
            if(isset($reg_glob_dbg)){ $reg_global_steps .= "Register: HTTP_COOKIE_VARS (".count($GLOBALS["HTTP_COOKIE_VARS"]).")<br>\n"; }
            foreach($GLOBALS["HTTP_COOKIE_VARS"] as $key => $value){
                $GLOBALS[$key] = $GLOBALS["HTTP_COOKIE_VARS"][$key];
            }
        }
        else{
            if(isset($reg_glob_dbg)){ $reg_global_steps .= "Register: _COOKIE (".count($GLOBALS["_COOKIE"]).")<br>\n"; }
            foreach($GLOBALS["_COOKIE"] as $key => $value){
                $GLOBALS[$key] = $GLOBALS["_COOKIE"][$key];
            }
        }
        
        // register post variables to global
        if(isset($GLOBALS["HTTP_POST_VARS"])){
            if(isset($reg_glob_dbg)){ $reg_global_steps .= "Register: HTTP_POST_VARS (".count($GLOBALS["HTTP_POST_VARS"]).")<br>\n"; }
            foreach($GLOBALS["HTTP_POST_VARS"] as $key => $value){
                $GLOBALS[$key] = $GLOBALS["HTTP_POST_VARS"][$key];
            }
        }
        else{
            if(isset($reg_glob_dbg)){ $reg_global_steps .= "Register: _POST (".count($GLOBALS["_POST"]).")<br>\n"; }
            foreach($GLOBALS["_POST"] as $key => $value){
                $GLOBALS[$key] = $GLOBALS["_POST"][$key];
            }
        }
        
        // register get variables to global
        if(isset($GLOBALS["HTTP_GET_VARS"])){
            if(isset($reg_glob_dbg)){ $reg_global_steps .= "Register: HTTP_GET_VARS (".count($GLOBALS["HTTP_GET_VARS"]).")<br>\n"; }
            foreach($GLOBALS["HTTP_GET_VARS"] as $key => $value){
                $GLOBALS[$key] = $GLOBALS["HTTP_GET_VARS"][$key];
            }
        }
        else{
            if(isset($reg_glob_dbg)){ $reg_global_steps .= "Register: _GET (".count($GLOBALS["_GET"]).")<br>\n"; }
            foreach($GLOBALS["_GET"] as $key => $value){
                $GLOBALS[$key] = $GLOBALS["_GET"][$key];
            }
        }
        
        // register file variables to global
        if(isset($GLOBALS["HTTP_POST_FILES"])){
            if(isset($reg_glob_dbg)){ $reg_global_steps .= "Register: HTTP_POST_FILES (".count($GLOBALS["HTTP_POST_FILES"]).")<br>\n"; }
            foreach($GLOBALS["HTTP_POST_FILES"] as $key => $value){
                $GLOBALS[$key] = $GLOBALS["HTTP_POST_FILES"][$key];
            }
        }
        else{
            if(isset($reg_glob_dbg)){ $reg_global_steps .= "Register: _FILES (".count($GLOBALS["_FILES"]).")<br>\n"; }
            foreach($GLOBALS["_FILES"] as $key => $value){
                $GLOBALS[$key] = $GLOBALS["_FILES"][$key];
            }
        }
        
        session_start();
        // register session variables to global
        if($GLOBALS["HTTP_SESSION_VARS"] || $GLOBALS["_SESSION"]){
            session_set_cookie_params(0, $GLOBALS["SCRIPT_NAME"], $GLOBALS["SERVER_NAME"]);
            if(isset($GLOBALS["HTTP_SESSION_VARS"])){
                if(isset($reg_glob_dbg)){ $reg_global_steps .= "Register Session: HTTP_SESSION_VARS (".count($GLOBALS["HTTP_SESSION_VARS"]).")<br>\n"; }
                foreach($GLOBALS["HTTP_SESSION_VARS"] as $key => $value){
                    $GLOBALS[$key] = $GLOBALS["HTTP_SESSION_VARS"][$key];
                }
            }
            else{
                if(isset($reg_glob_dbg)){ $reg_global_steps .= "Register Session: _SESSION (".count($GLOBALS["_SESSION"]).")<br>\n"; }
                foreach($GLOBALS["_SESSION"] as $key => $value){
                    $GLOBALS[$key] = $GLOBALS["_SESSION"][$key];
                }
            }
        }
        
        // printout steps
        if(isset($reg_glob_dbg)){ echo $reg_global_steps; }
        if(isset($reg_glob_dbg)){ print_var($GLOBALS); }
        
    }
    else {
        if($GLOBALS["HTTP_COOKIE_VARS"]["PHPSESSID"]){ 
            if(isset($reg_glob_dbg)){ $reg_global_steps .= "Register Session: register_global=on<br>\n"; }
            session_set_cookie_params(0, $SCRIPT_NAME, $SERVER_NAME);
            session_start(); 
        }
        
        // printout steps
        if(isset($reg_glob_dbg)){ echo $reg_global_steps; }
    }
}

?>
